Index: src/includes/classes/Smarty/sysplugins/smarty_resource.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_resource.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_resource.php	(revision )
@@ -17,36 +17,37 @@
 abstract class Smarty_Resource
 {
     /**
-     * cache for Smarty_Template_Source instances
+     * Source is bypassing compiler
      *
-     * @var array
+     * @var boolean
      */
-    public static $sources = array();
+    public $uncompiled = false;
+
     /**
-     * cache for Smarty_Template_Compiled instances
+     * Source must be recompiled on every occasion
      *
-     * @var array
+     * @var boolean
      */
-    public static $compileds = array();
+    public $recompiled = false;
+
     /**
-     * cache for Smarty_Resource instances
+     * resource types provided by the core
      *
      * @var array
      */
-    public static $resources = array();
+    public static $sysplugins = array('file'    => 'smarty_internal_resource_file.php',
+                                      'string'  => 'smarty_internal_resource_string.php',
+                                      'extends' => 'smarty_internal_resource_extends.php',
+                                      'stream'  => 'smarty_internal_resource_stream.php',
+                                      'eval'    => 'smarty_internal_resource_eval.php',
+                                      'php'     => 'smarty_internal_resource_php.php');
+
     /**
-     * resource types provided by the core
+     * Flag if resource does implement populateCompiledFilepath() method
      *
-     * @var array
+     * @var bool
      */
-    protected static $sysplugins = array(
-        'file'    => true,
-        'string'  => true,
-        'extends' => true,
-        'stream'  => true,
-        'eval'    => true,
-        'php'     => true
-    );
+    public $hasCompiledHandler = false;
 
     /**
      * Name of the Class to compile this resource's contents with
@@ -71,7 +72,6 @@
 
     /**
      * Load template's source into current template object
-     * {@internal The loaded source is assigned to $_template->source->content directly.}}
      *
      * @param  Smarty_Template_Source $source source object
      *
@@ -103,278 +103,33 @@
      *
      * @param  Smarty  $smarty        Smarty instance
      * @param  string  $resource_name resource_name to make unique
-     * @param  boolean $is_config     flag for config resource
+     * @param  boolean $isConfig      flag for config resource
      *
      * @return string unique resource name
      */
-    protected function buildUniqueResourceName(Smarty $smarty, $resource_name, $is_config = false)
+    public function buildUniqueResourceName(Smarty $smarty, $resource_name, $isConfig = false)
     {
-        if ($is_config) {
-            return get_class($this) . '#' . $smarty->joined_config_dir . '#' . $resource_name;
-        } else {
-            return get_class($this) . '#' . $smarty->joined_template_dir . '#' . $resource_name;
+        if ($isConfig) {
+            if (!isset($smarty->_joined_config_dir)) {
+                $smarty->getTemplateDir(null, true);
-        }
+            }
-    }
-
-    /**
-     * populate Compiled Object with compiled filepath
-     *
-     * @param Smarty_Template_Compiled $compiled  compiled object
-     * @param Smarty_Internal_Template $_template template object
-     */
-    public function populateCompiledFilepath(Smarty_Template_Compiled $compiled, Smarty_Internal_Template $_template)
-    {
-        $_compile_id = isset($_template->compile_id) ? preg_replace('![^\w\|]+!', '_', $_template->compile_id) : null;
-        $_filepath = $compiled->source->uid;
-        // if use_sub_dirs, break file into directories
-        if ($_template->smarty->use_sub_dirs) {
-            $_filepath = substr($_filepath, 0, 2) . DS
-                . substr($_filepath, 2, 2) . DS
-                . substr($_filepath, 4, 2) . DS
-                . $_filepath;
-        }
-        $_compile_dir_sep = $_template->smarty->use_sub_dirs ? DS : '^';
-        if (isset($_compile_id)) {
-            $_filepath = $_compile_id . $_compile_dir_sep . $_filepath;
-        }
-        // caching token
-        if ($_template->caching) {
-            $_cache = '.cache';
+            return get_class($this) . '#' . $smarty->_joined_config_dir . '#' . $resource_name;
         } else {
-            $_cache = '';
+            if (!isset($smarty->_joined_template_dir)) {
+                $smarty->getTemplateDir();
-        }
+            }
-        $_compile_dir = $_template->smarty->getCompileDir();
-        // set basename if not specified
-        $_basename = $this->getBasename($compiled->source);
-        if ($_basename === null) {
-            $_basename = basename(preg_replace('![^\w\/]+!', '_', $compiled->source->name));
+            return get_class($this) . '#' . $smarty->_joined_template_dir . '#' . $resource_name;
         }
-        // separate (optional) basename by dot
-        if ($_basename) {
-            $_basename = '.' . $_basename;
-        }
+    }
 
-        $compiled->filepath = $_compile_dir . $_filepath . '.' . $compiled->source->type . $_basename . $_cache . '.php';
-    }
-
     /**
-     * Normalize Paths "foo/../bar" to "bar"
-     *
-     * @param  string  $_path path to normalize
-     * @param  boolean $ds    respect windows directory separator
-     *
-     * @return string  normalized path
-     */
-    protected function normalizePath($_path, $ds = true)
-    {
-        if ($ds) {
-            // don't we all just love windows?
-            $_path = str_replace('\\', '/', $_path);
-        }
-
-        $offset = 0;
-
-        // resolve simples
-        $_path = preg_replace('#/\./(\./)*#', '/', $_path);
-        // resolve parents
-        while (true) {
-            $_parent = strpos($_path, '/../', $offset);
-            if (!$_parent) {
-                break;
-            } elseif ($_path[$_parent - 1] === '.') {
-                $offset = $_parent + 3;
-                continue;
-            }
-
-            $_pos = strrpos($_path, '/', $_parent - strlen($_path) - 1);
-            if ($_pos === false) {
-                // don't we all just love windows?
-                $_pos = $_parent;
-            }
-
-            $_path = substr_replace($_path, '', $_pos, $_parent + 3 - $_pos);
-        }
-
-        if ($ds && DS != '/') {
-            // don't we all just love windows?
-            $_path = str_replace('/', '\\', $_path);
-        }
-
-        return $_path;
-    }
-
-    /**
-     * build template filepath by traversing the template_dir array
-     *
-     * @param  Smarty_Template_Source   $source    source object
-     * @param  Smarty_Internal_Template $_template template object
-     *
-     * @return string                   fully qualified filepath
-     * @throws SmartyException          if default template handler is registered but not callable
-     */
-    protected function buildFilepath(Smarty_Template_Source $source, Smarty_Internal_Template $_template = null)
-    {
-        $file = $source->name;
-        if ($source instanceof Smarty_Config_Source) {
-            $_directories = $source->smarty->getConfigDir();
-            $_default_handler = $source->smarty->default_config_handler_func;
-        } else {
-            $_directories = $source->smarty->getTemplateDir();
-            $_default_handler = $source->smarty->default_template_handler_func;
-        }
-
-        // go relative to a given template?
-        $_file_is_dotted = $file[0] == '.' && ($file[1] == '.' || $file[1] == '/' || $file[1] == "\\");
-        if ($_template && $_template->parent instanceof Smarty_Internal_Template && $_file_is_dotted) {
-            if ($_template->parent->source->type != 'file' && $_template->parent->source->type != 'extends' && !$_template->parent->allow_relative_path) {
-                throw new SmartyException("Template '{$file}' cannot be relative to template of resource type '{$_template->parent->source->type}'");
-            }
-            $file = dirname($_template->parent->source->filepath) . DS . $file;
-            $_file_exact_match = true;
-            if (!preg_match('/^([\/\\\\]|[a-zA-Z]:[\/\\\\])/', $file)) {
-                // the path gained from the parent template is relative to the current working directory
-                // as expansions (like include_path) have already been done
-                $file = getcwd() . DS . $file;
-            }
-        }
-
-        // resolve relative path
-        if (!preg_match('/^([\/\\\\]|[a-zA-Z]:[\/\\\\])/', $file)) {
-            // don't we all just love windows?
-            $_path = DS . trim($file, '/');
-            $_was_relative = true;
-        } else {
-            // don't we all just love windows?
-            $_path = str_replace('\\', '/', $file);
-        }
-        $_path = $this->normalizePath($_path, false);
-        if (DS != '/') {
-            // don't we all just love windows?
-            $_path = str_replace('/', '\\', $_path);
-        }
-        // revert to relative
-        if (isset($_was_relative)) {
-            $_path = substr($_path, 1);
-        }
-
-        // this is only required for directories
-        $file = rtrim($_path, '/\\');
-
-        // files relative to a template only get one shot
-        if (isset($_file_exact_match)) {
-            return $this->fileExists($source, $file) ? $file : false;
-        }
-
-        // template_dir index?
-        if (preg_match('#^\[(?P<key>[^\]]+)\](?P<file>.+)$#', $file, $match)) {
-            $_directory = null;
-            // try string indexes
-            if (isset($_directories[$match['key']])) {
-                $_directory = $_directories[$match['key']];
-            } elseif (is_numeric($match['key'])) {
-                // try numeric index
-                $match['key'] = (int) $match['key'];
-                if (isset($_directories[$match['key']])) {
-                    $_directory = $_directories[$match['key']];
-                } else {
-                    // try at location index
-                    $keys = array_keys($_directories);
-                    $_directory = $_directories[$keys[$match['key']]];
-                }
-            }
-
-            if ($_directory) {
-                $_file = substr($file, strpos($file, ']') + 1);
-                $_filepath = $_directory . $_file;
-                if ($this->fileExists($source, $_filepath)) {
-                    return $_filepath;
-                }
-            }
-        }
-
-        $_stream_resolve_include_path = function_exists('stream_resolve_include_path');
-
-        // relative file name?
-        if (!preg_match('/^([\/\\\\]|[a-zA-Z]:[\/\\\\])/', $file)) {
-            foreach ($_directories as $_directory) {
-                $_filepath = $_directory . $file;
-                if ($this->fileExists($source, $_filepath)) {
-                    return $this->normalizePath($_filepath);
-                }
-                if ($source->smarty->use_include_path && !preg_match('/^([\/\\\\]|[a-zA-Z]:[\/\\\\])/', $_directory)) {
-                    // try PHP include_path
-                    if ($_stream_resolve_include_path) {
-                        $_filepath = stream_resolve_include_path($_filepath);
-                    } else {
-                        $_filepath = Smarty_Internal_Get_Include_Path::getIncludePath($_filepath);
-                    }
-
-                    if ($_filepath !== false) {
-                        if ($this->fileExists($source, $_filepath)) {
-                            return $this->normalizePath($_filepath);
-                        }
-                    }
-                }
-            }
-        }
-
-        // try absolute filepath
-        if ($this->fileExists($source, $file)) {
-            return $file;
-        }
-
-        // no tpl file found
-        if ($_default_handler) {
-            if (!is_callable($_default_handler)) {
-                if ($source instanceof Smarty_Config_Source) {
-                    throw new SmartyException("Default config handler not callable");
-                } else {
-                    throw new SmartyException("Default template handler not callable");
-                }
-            }
-            $_return = call_user_func_array($_default_handler,
-                                            array($source->type, $source->name, &$_content, &$_timestamp, $source->smarty));
-            if (is_string($_return)) {
-                $source->timestamp = @filemtime($_return);
-                $source->exists = !!$source->timestamp;
-
-                return $_return;
-            } elseif ($_return === true) {
-                $source->content = $_content;
-                $source->timestamp = $_timestamp;
-                $source->exists = true;
-
-                return $_filepath;
-            }
-        }
-
-        // give up
-        return false;
-    }
-
-    /**
-     * test is file exists and save timestamp
-     *
-     * @param  Smarty_Template_Source $source source object
-     * @param  string                 $file   file name
-     *
-     * @return bool                   true if file exists
-     */
-    protected function fileExists(Smarty_Template_Source $source, $file)
-    {
-        $source->timestamp = is_file($file) ? @filemtime($file) : false;
-
-        return $source->exists = !!$source->timestamp;
-    }
-
-    /**
      * Determine basename for compiled filename
      *
      * @param  Smarty_Template_Source $source source object
      *
      * @return string                 resource's basename
      */
-    protected function getBasename(Smarty_Template_Source $source)
+    public function getBasename(Smarty_Template_Source $source)
     {
         return null;
     }
@@ -391,57 +146,32 @@
     public static function load(Smarty $smarty, $type)
     {
         // try smarty's cache
-        if (isset($smarty->_resource_handlers[$type])) {
-            return $smarty->_resource_handlers[$type];
+        if (isset($smarty->_cache['resource_handlers'][$type])) {
+            return $smarty->_cache['resource_handlers'][$type];
         }
 
         // try registered resource
         if (isset($smarty->registered_resources[$type])) {
-            if ($smarty->registered_resources[$type] instanceof Smarty_Resource) {
-                $smarty->_resource_handlers[$type] = $smarty->registered_resources[$type];
-                // note registered to smarty is not kept unique!
-                return $smarty->_resource_handlers[$type];
+            return $smarty->_cache['resource_handlers'][$type] =
+                $smarty->registered_resources[$type] instanceof Smarty_Resource ? $smarty->registered_resources[$type] :
+                    new Smarty_Internal_Resource_Registered();
-            }
+        }
 
-            if (!isset(self::$resources['registered'])) {
-                self::$resources['registered'] = new Smarty_Internal_Resource_Registered();
-            }
-            if (!isset($smarty->_resource_handlers[$type])) {
-                $smarty->_resource_handlers[$type] = self::$resources['registered'];
-            }
-
-            return $smarty->_resource_handlers[$type];
-        }
-
         // try sysplugins dir
         if (isset(self::$sysplugins[$type])) {
-            if (!isset(self::$resources[$type])) {
-                $_resource_class = 'Smarty_Internal_Resource_' . ucfirst($type);
+            $_resource_class = 'Smarty_Internal_Resource_' . ucfirst($type);
-                self::$resources[$type] = new $_resource_class();
+            return $smarty->_cache['resource_handlers'][$type] = new $_resource_class();
-            }
+        }
 
-            return $smarty->_resource_handlers[$type] = self::$resources[$type];
-        }
-
         // try plugins dir
         $_resource_class = 'Smarty_Resource_' . ucfirst($type);
         if ($smarty->loadPlugin($_resource_class)) {
-            if (isset(self::$resources[$type])) {
-                return $smarty->_resource_handlers[$type] = self::$resources[$type];
-            }
-
             if (class_exists($_resource_class, false)) {
-                self::$resources[$type] = new $_resource_class();
-
-                return $smarty->_resource_handlers[$type] = self::$resources[$type];
+                return $smarty->_cache['resource_handlers'][$type] = new $_resource_class();
             } else {
-                $smarty->registerResource($type, array(
-                    "smarty_resource_{$type}_source",
-                    "smarty_resource_{$type}_timestamp",
-                    "smarty_resource_{$type}_secure",
-                    "smarty_resource_{$type}_trusted"
-                ));
-
+                $smarty->registerResource($type,
+                                          array("smarty_resource_{$type}_source", "smarty_resource_{$type}_timestamp",
+                                                "smarty_resource_{$type}_secure", "smarty_resource_{$type}_trusted"));
                 // give it another try, now that the resource is registered properly
                 return self::load($smarty, $type);
             }
@@ -454,13 +184,9 @@
             if (is_object($smarty->security_policy)) {
                 $smarty->security_policy->isTrustedStream($type);
             }
-            if (!isset(self::$resources['stream'])) {
-                self::$resources['stream'] = new Smarty_Internal_Resource_Stream();
+            return $smarty->_cache['resource_handlers'][$type] = new Smarty_Internal_Resource_Stream();
-            }
+        }
 
-            return $smarty->_resource_handlers[$type] = self::$resources['stream'];
-        }
-
         // TODO: try default_(template|config)_handler
 
         // give up
@@ -473,57 +199,60 @@
      *
      * @param  string $resource_name    template_resource or config_resource to parse
      * @param  string $default_resource the default resource_type defined in $smarty
-     * @param  string &$name            the parsed resource name
-     * @param  string &$type            the parsed resource type
      *
-     * @return void
+     * @return array with parsed resource name and type
      */
-    protected static function parseResourceName($resource_name, $default_resource, &$name, &$type)
+    public static function parseResourceName($resource_name, $default_resource)
     {
-        $parts = explode(':', $resource_name, 2);
-        if (!isset($parts[1]) || !isset($parts[0][1])) {
+        if (preg_match('/^([A-Za-z0-9_\-]{2,})[:]/', $resource_name, $match)) {
+            $type = $match[1];
+            $name = substr($resource_name, strlen($match[0]));
+        } else {
             // no resource given, use default
             // or single character before the colon is not a resource type, but part of the filepath
             $type = $default_resource;
             $name = $resource_name;
-        } else {
-            $type = $parts[0];
-            $name = $parts[1];
         }
+        return array($name, $type);
     }
 
     /**
-     * modify resource_name according to resource handlers specifications
-     *
-     * @param  Smarty $smarty        Smarty instance
-     * @param  string $resource_name resource_name to make unique
-     *
-     * @return string unique resource name
-     */
-
-    /**
      * modify template_resource according to resource handlers specifications
      *
-     * @param  Smarty_Internal_template $template          Smarty instance
+     * @param  \Smarty_Internal_Template|\Smarty $obj               Smarty instance
-     * @param  string                   $template_resource template_resource to extract resource handler and name of
+     * @param  string                            $template_resource template_resource to extract resource handler and name of
      *
      * @return string unique resource name
      */
-    public static function getUniqueTemplateName($template, $template_resource)
+    public static function getUniqueTemplateName($obj, $template_resource)
     {
-        self::parseResourceName($template_resource, $template->smarty->default_resource_type, $name, $type);
+        $smarty = $obj->_objType == 2 ? $obj->smarty : $obj;
+        list($name, $type) = self::parseResourceName($template_resource, $smarty->default_resource_type);
         // TODO: optimize for Smarty's internal resource types
-        $resource = Smarty_Resource::load($template->smarty, $type);
+        $resource = Smarty_Resource::load($smarty, $type);
         // go relative to a given template?
-        $_file_is_dotted = $name[0] == '.' && ($name[1] == '.' || $name[1] == '/' || $name[1] == "\\");
-        if ($template instanceof Smarty_Internal_Template && $_file_is_dotted && ($template->source->type == 'file' || $template->parent->source->type == 'extends')) {
-            $name = dirname($template->source->filepath) . DS . $name;
+        $_file_is_dotted = $name[0] == '.' && ($name[1] == '.' || $name[1] == '/');
+        if ($obj->_objType == 2 && $_file_is_dotted &&
+            ($obj->source->type == 'file' || $obj->parent->source->type == 'extends')
+        ) {
+            $name = dirname($obj->source->filepath) . DS . $name;
         }
-        return $resource->buildUniqueResourceName($template->smarty, $name);
+        return $resource->buildUniqueResourceName($smarty, $name);
     }
 
+    /*
+     * Check if resource must check time stamps when when loading complied or cached templates.
+     * Resources like 'extends' which use source components my disable timestamp checks on own resource.
+     *
+     * @return bool
+     */
+    public function checkTimestamps() {
+        return true;
+    }
+
     /**
      * initialize Source Object for given resource
+     * wrapper for backward compatibility to versions < 3.1.22
      * Either [$_template] or [$smarty, $template_resource] must be specified
      *
      * @param  Smarty_Internal_Template $_template         template object
